//
//  AppDelegate.swift
//
//  Copyright (C) 2015-2016 Hiroshi Kanemoto.
//	Released under the MIT license
//	http://opensource.org/licenses/mit-license.php
//
//	 Created:	2016/04/04	H.Kanemoto
//	Modified:
//
import UIKit
import GameController

@UIApplicationMain
class AppDelegate: UIResponder, UIApplicationDelegate {

	var window: UIWindow?
	fileprivate var bmpimg:DblBuffBmpImage!
	fileprivate var n80:n80em!
	fileprivate var notify:NotificationCenter!
	
	internal var SMBIP:String = "192.168."
	internal var SMBUser:String = ""
	internal var SMBPassword:String = ""
	internal var SMBSign:Bool = false
	
	internal var mfictr:[GCController] = [GCController]()
	internal var useMFI:Bool = false
	internal var mfiDir:VPSTICK = VPSTICK.newtoral
	internal var mfiButton1Pushed:Bool = false
	internal var mfiButton2Pushed:Bool = false
	internal var mfiButton3Pushed:Bool = false
	
	internal var keys:[N80Key] = [N80Key]()
	internal var keys0:[N80Key] = [N80Key]()
	internal var keys1:[N80Key] = [N80Key]()
	internal var keys2:[N80Key] = [N80Key]()
	internal var keys3:[N80Key] = [N80Key]()
	internal var keys4:[N80Key] = [N80Key]()
	internal var keys5:[N80Key] = [N80Key]()
	internal var keys6:[N80Key] = [N80Key]()
	
    internal var Interrace:Bool = true;
	internal var StickType:VPSTICK_STICKTYPE = VPSTICK_STICKTYPE.adjust_CENTER
	internal var StickDir:VPSTICK_STICKDIR = VPSTICK_STICKDIR.dir_8
	internal var Button1Pt:CGPoint!
	internal var Button2Pt:CGPoint!
	internal var Button3Pt:CGPoint!
	internal var Button1Size:CGFloat!
	internal var Button2Size:CGFloat!
	internal var Button3Size:CGFloat!
	internal var Button1Label:String = "SP"
	internal var Button2Label:String = "Z"
	internal var Button3Label:String = "X"
	internal var maxScalar:Double = 15
	internal var playOfStick:Double = 5
	
	internal var N80EM:n80em {
		return self.n80
	}
	internal var BmpImg:DblBuffBmpImage {
		return self.bmpimg
	}

	func application(_ application: UIApplication, didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?) -> Bool {
		// Override point for customization after application launch.
		let userdef = UserDefaults.standard
        userdef.register(defaults: ["interrace" : Bool(true)])
		userdef.register(defaults: ["sticktype": VPSTICK_STICKTYPE.adjust_CENTER.rawValue])
		userdef.register(defaults: ["stickdir": VPSTICK_STICKDIR.dir_8.rawValue])
		userdef.register(defaults: ["maxscalar": Double(15)])
		userdef.register(defaults: ["playofstick": Double(5)])
		userdef.register(defaults: ["button1label": "SP"])
		userdef.register(defaults: ["button2label": "Z"])
		userdef.register(defaults: ["button3label": "X"])
		userdef.register(defaults: ["button1ptx": Float(UIScreen.main.bounds.width - 60)])
		userdef.register(defaults: ["button1pty": Float(UIScreen.main.bounds.height - 300)])
		userdef.register(defaults: ["button2ptx": Float(UIScreen.main.bounds.width - 120)])
		userdef.register(defaults: ["button2pty": Float(UIScreen.main.bounds.height - 230)])
		userdef.register(defaults: ["button3ptx": Float(UIScreen.main.bounds.width - 60)])
		userdef.register(defaults: ["button3pty": Float(UIScreen.main.bounds.height - 230)])
		userdef.register(defaults: ["button1size": Float(50)])
		userdef.register(defaults: ["button2size": Float(50)])
		userdef.register(defaults: ["button3size": Float(50)])
		userdef.register(defaults: ["smbip": "192.168."])
		userdef.register(defaults: ["smbuser": ""])
		userdef.register(defaults: ["smbpass": ""])
		userdef.register(defaults: ["smbsign": false])
		
		self.SMBIP = userdef.string(forKey: "smbip")!
		self.SMBUser = userdef.string(forKey: "smbuser")!
		self.SMBPassword = userdef.string(forKey: "smbpass")!
		self.SMBSign = userdef.bool(forKey: "smbsign")

        self.Interrace = userdef.bool(forKey: "interrace")
		self.StickType = VPSTICK_STICKTYPE(rawValue: userdef.integer(forKey: "sticktype"))!
		self.StickDir = VPSTICK_STICKDIR(rawValue: userdef.integer(forKey: "stickdir"))!
		self.maxScalar = userdef.double(forKey: "maxscalar")
		self.playOfStick = userdef.double(forKey: "playofstick")
		self.Button1Label = userdef.string(forKey: "button1label")!
		self.Button2Label = userdef.string(forKey: "button2label")!
		self.Button3Label = userdef.string(forKey: "button3label")!
		self.Button1Pt = CGPoint(x: CGFloat(userdef.float(forKey: "button1ptx")), y: CGFloat(userdef.float(forKey: "button1pty")))
		self.Button2Pt = CGPoint(x: CGFloat(userdef.float(forKey: "button2ptx")), y: CGFloat(userdef.float(forKey: "button2pty")))
		self.Button3Pt = CGPoint(x: CGFloat(userdef.float(forKey: "button3ptx")), y: CGFloat(userdef.float(forKey: "button3pty")))
		self.Button1Size = CGFloat(userdef.float(forKey: "button1size"))
		self.Button2Size = CGFloat(userdef.float(forKey: "button2size"))
		self.Button3Size = CGFloat(userdef.float(forKey: "button3size"))
		
		self.notify = NotificationCenter.default
		self.notify?.addObserver(forName: NSNotification.Name.GCControllerDidConnect, object: nil, queue: nil) {(nf:Notification) -> Void in  self.setupControllers(nf)
		}
		self.notify?.addObserver(forName: NSNotification.Name.GCControllerDidDisconnect, object: nil, queue: nil) {(nf:Notification) -> Void in  self.setupControllers(nf)
		}
		/*self.notify.addObserver(self, selector: #selector(type(of: self).setupControllers(_:)), name: NSNotification.Name.GCControllerDidConnect, object: nil)
		self.notify.addObserver(self, selector: #selector(type(of: self).setupControllers(_:)), name: NSNotification.Name.GCControllerDidDisconnect, object: nil)*/
		//self.setupControllersCore()
		
		self.bmpimg = DblBuffBmpImage(640, 400)
        self.n80 = n80em(dma: self.bmpimg, interrace: self.Interrace)
		for y:Int32 in 0 ..< 400 {
			for x:Int32 in 0 ..< 640 {
				self.bmpimg.setPixel(false, x: x, y: y, r: 0, g: 0, b: 0xff)
			}
		}
		self.bmpimg.flip()
		self.prepareKeys()
		
		return true
	}
	
	func applicationWillResignActive(_ application: UIApplication) {
		// Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
		// Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
		//self.N80EM.enterPause()
		
	}

	func applicationDidEnterBackground(_ application: UIApplication) {
		// Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
		// If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
		NSLog("applicationDidEnterBackground")
		self.n80.suspend();
	}

	func applicationWillEnterForeground(_ application: UIApplication) {
		// Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
		//self.N80EM.leavePause(false)
		self.n80.resume();
	}

	func applicationDidBecomeActive(_ application: UIApplication) {
		// Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
	}

	func applicationWillTerminate(_ application: UIApplication) {
		// Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
		self.N80EM.leavePause(true)
		self.N80EM.reqDispose()
		self.keys.removeAll()
		self.keys0.removeAll()
		self.keys1.removeAll()
		self.keys2.removeAll()
		self.keys3.removeAll()
		self.keys4.removeAll()
		self.keys5.removeAll()
		self.notify.removeObserver(self)
		self.notify.removeObserver(self, name: NSNotification.Name.GCControllerDidConnect, object: nil)
		self.notify.removeObserver(self, name: NSNotification.Name.GCControllerDidDisconnect, object: nil)
	}
	
	func setupControllers(_ nf:Notification) {
		// called when bluetooth mfi device is connected or disconnected
		self.setupControllersCore()
	}
	
	func setupControllersCore() {
		self.mfictr = GCController.controllers()
		self.useMFI = self.mfictr.count > 0
		if !self.useMFI {
			self.mfiDir = VPSTICK.newtoral
			self.mfiButton1Pushed = false
			self.mfiButton2Pushed = false
			self.mfiButton3Pushed = false
		}
	}
	
	internal func saveUserDefault() {
		let userdef = UserDefaults.standard
		
        userdef.set(self.Interrace, forKey: "interrace")
		userdef.set(self.StickType.rawValue, forKey: "sticktype")
		userdef.set(self.StickDir.rawValue, forKey: "stickdir")
		userdef.set(self.maxScalar, forKey: "maxscalar")
		userdef.set(self.playOfStick, forKey: "playofstick")
		userdef.set(self.Button1Label, forKey: "button1label")
		userdef.set(self.Button2Label, forKey: "button2label")
		userdef.set(self.Button3Label, forKey: "button3label")
		userdef.set(Float(self.Button1Pt.x), forKey: "button1ptx")
		userdef.set(Float(self.Button1Pt.y), forKey: "button1pty")
		userdef.set(Float(self.Button2Pt.x), forKey: "button2ptx")
		userdef.set(Float(self.Button2Pt.y), forKey: "button2pty")
		userdef.set(Float(self.Button3Pt.x), forKey: "button3ptx")
		userdef.set(Float(self.Button3Pt.y), forKey: "button3pty")
		userdef.set(Float(self.Button1Size), forKey: "button1size")
		userdef.set(Float(self.Button2Size), forKey: "button2size")
		userdef.set(Float(self.Button3Size), forKey: "button3size")
		userdef.synchronize()
	}
	
	internal func saveSMBDefault() {
		let userdef = UserDefaults.standard
		
		userdef.set(self.SMBIP, forKey: "smbip")
		userdef.set(self.SMBUser, forKey: "smbuser")
		userdef.set(self.SMBPassword, forKey: "smbpass")
		userdef.set(self.SMBSign, forKey: "smbsign")
		userdef.synchronize()
	}
	
	internal func setInitialValues() {
        self.Interrace = true
		self.StickType = VPSTICK_STICKTYPE.adjust_CENTER
		self.StickDir = VPSTICK_STICKDIR.dir_8
		self.maxScalar = 15
		self.playOfStick = 5
		self.Button1Label = "SP"
		self.Button2Label = "Z"
		self.Button3Label = "X"
		self.Button1Pt = CGPoint(x: UIScreen.main.bounds.width - 60, y: UIScreen.main.bounds.height - 300)
		self.Button2Pt = CGPoint(x: UIScreen.main.bounds.width - 120, y: UIScreen.main.bounds.height - 230)
		self.Button3Pt = CGPoint(x: UIScreen.main.bounds.width - 60, y: UIScreen.main.bounds.height - 230)
		self.Button1Size = 50
		self.Button2Size = 50
		self.Button3Size = 50
	}
	
	internal func findKeyByLable(_ lable:String) -> N80Key? {
		let appDelegate:AppDelegate = UIApplication.shared.delegate as! AppDelegate
		for k in appDelegate.keys {
			if k.Lable == lable {
				return k
			}
		}
		return nil
	}
	
	internal func clearKey() {
		let appDelegate:AppDelegate = UIApplication.shared.delegate as! AppDelegate
		for k in appDelegate.keys {
			k.Pushed = false
		}
		N80Key.Shift = false
		self.N80EM.keyClear()	//clear N80 key I/O buffer
	}
	
	func prepareKeys() {
		self.keys0.append(N80Key(code: 0x81, label:"TP", isNormal:false))
        self.keys0.append(N80Key(code: 0x83, label:"SB", isNormal:false))
		self.keys0.append(N80Key(code: 0x90, label:"CF", isNormal:false))
		self.keys0.append(N80Key(code: 0x49, label:"F1"))
		self.keys0.append(N80Key(code: 0x4a, label:"F2"))
		self.keys0.append(N80Key(code: 0x4b, label:"F3"))
		self.keys0.append(N80Key(code: 0x4c, label:"F4"))
		self.keys0.append(N80Key(code: 0x4d, label:"F5"))
		self.keys0.append(N80Key(code: 0x40, label:"HM"))
		self.keys0.append(N80Key(code: 0x80, label:"RS", isNormal:false))
		
		self.keys1.append(N80Key(code: 0x31, label:"1"))
		self.keys1.append(N80Key(code: 0x32, label:"2"))
		self.keys1.append(N80Key(code: 0x33, label:"3"))
		self.keys1.append(N80Key(code: 0x34, label:"4"))
		self.keys1.append(N80Key(code: 0x35, label:"5"))
		self.keys1.append(N80Key(code: 0x36, label:"6"))
		self.keys1.append(N80Key(code: 0x37, label:"7"))
		self.keys1.append(N80Key(code: 0x38, label:"8"))
		self.keys1.append(N80Key(code: 0x39, label:"9"))
		self.keys1.append(N80Key(code: 0x30, label:"0"))
		self.keys1.append(N80Key(code: 0x2f, label:"="))
		self.keys1.append(N80Key(code: 0x2e, label:"^"))
		self.keys1.append(N80Key(code: 0x2c, label:"¥"))
		self.keys1.append(N80Key(code: 0x48, label:"ST", isNormal:false))
		self.keys1.append(N80Key(code: 0x43, label:"DL", isNormal:false))
		
		self.keys2.append(N80Key(code: 0x4f, label:"EC"))
		self.keys2.append(N80Key(code: 0x21, label:"Q"))
		self.keys2.append(N80Key(code: 0x27, label:"W"))
		self.keys2.append(N80Key(code: 0x15, label:"E"))
		self.keys2.append(N80Key(code: 0x22, label:"R"))
		self.keys2.append(N80Key(code: 0x24, label:"T"))
		self.keys2.append(N80Key(code: 0x29, label:"Y"))
		self.keys2.append(N80Key(code: 0x25, label:"U"))
		self.keys2.append(N80Key(code: 0x19, label:"I"))
		self.keys2.append(N80Key(code: 0x1f, label:"O"))
		self.keys2.append(N80Key(code: 0x20, label:"P"))
		self.keys2.append(N80Key(code: 0x10, label:"@"))
		self.keys2.append(N80Key(code: 0x2b, label:"["))
		self.keys2.append(N80Key(code: 0x0f, label:"RET"))
		
		self.keys3.append(N80Key(code: 0x47, label:"CN", isNormal:false))
		self.keys3.append(N80Key(code: 0x11, label:"A"))
		self.keys3.append(N80Key(code: 0x23, label:"S"))
		self.keys3.append(N80Key(code: 0x14, label:"D"))
		self.keys3.append(N80Key(code: 0x16, label:"F"))
		self.keys3.append(N80Key(code: 0x17, label:"G"))
		self.keys3.append(N80Key(code: 0x18, label:"H"))
		self.keys3.append(N80Key(code: 0x1a, label:"J"))
		self.keys3.append(N80Key(code: 0x1b, label:"K"))
		self.keys3.append(N80Key(code: 0x1c, label:"L"))
		self.keys3.append(N80Key(code: 0x3b, label:";"))
		self.keys3.append(N80Key(code: 0x3a, label:":"))
		self.keys3.append(N80Key(code: 0x2d, label:"]"))
		self.keys3.append(N80Key(code: 0x45, label:"ｶﾅ", isNormal:false))
		
		self.keys4.append(N80Key(code: 0x46, label:"SHIFT"))
		self.keys4.append(N80Key(code: 0x2a, label:"Z"))
		self.keys4.append(N80Key(code: 0x28, label:"X"))
		self.keys4.append(N80Key(code: 0x13, label:"C"))
		self.keys4.append(N80Key(code: 0x26, label:"V"))
		self.keys4.append(N80Key(code: 0x12, label:"B"))
		self.keys4.append(N80Key(code: 0x1e, label:"N"))
		self.keys4.append(N80Key(code: 0x1d, label:"M"))
		self.keys4.append(N80Key(code: 0x3c, label:","))
		self.keys4.append(N80Key(code: 0x3d, label:"."))
		self.keys4.append(N80Key(code: 0x3e, label:"?"))
		self.keys4.append(N80Key(code: 0x3f, label:"_"))
		self.keys4.append(N80Key(code: 0x46, label:"SHIFT"))
		
		self.keys5.append(N80Key(code: 0x44, label:"GR"))
		self.keys5.append(N80Key(code: 0x4e, label:"SP"))
		self.keys5.append(N80Key(code: 0x42, label:"LR", isNormal:false))
		self.keys5.append(N80Key(code: 0x41, label:"UD", isNormal:false))
		self.keys5.append(N80Key(code: 0x82, label:"PG", isNormal:false))

		self.keys6.append(N80Key(code: 0x00, label:"TEN0"))
		self.keys6.append(N80Key(code: 0x01, label:"TEN1"))
		self.keys6.append(N80Key(code: 0x02, label:"TEN2"))
		self.keys6.append(N80Key(code: 0x03, label:"TEN3"))
		self.keys6.append(N80Key(code: 0x04, label:"TEN4"))
		self.keys6.append(N80Key(code: 0x05, label:"TEN5"))
		self.keys6.append(N80Key(code: 0x06, label:"TEN6"))
		self.keys6.append(N80Key(code: 0x07, label:"TEN7"))
		self.keys6.append(N80Key(code: 0x08, label:"TEN8"))
		self.keys6.append(N80Key(code: 0x09, label:"TEN9"))
		self.keys6.append(N80Key(code: 0x0a, label:"TEN*"))
		self.keys6.append(N80Key(code: 0x0b, label:"TEN+"))
		self.keys6.append(N80Key(code: 0x0c, label:"TEN="))
		self.keys6.append(N80Key(code: 0x0d, label:"TEN,"))
		self.keys6.append(N80Key(code: 0x0e, label:"TEN."))
		
		
		for k in self.keys0 {
			self.keys.append(k)
		}
		for k in self.keys1 {
			self.keys.append(k)
		}
		for k in self.keys2 {
			self.keys.append(k)
		}
		for k in self.keys3 {
			self.keys.append(k)
		}
		for k in self.keys4 {
			self.keys.append(k)
		}
		for k in self.keys5 {
			self.keys.append(k)
		}
		for k in self.keys6 {
			self.keys.append(k)
		}
	}
}

