//
//  KBIndicatorLayer.swift
//
//  Copyright (C) 2016 Hiroshi Kanemoto.
//	Released under the MIT license
//	http://opensource.org/licenses/mit-license.php
//
//	 Created:	2016/04/09	H.Kanemoto
//	Modified:
//
import Foundation

open class KBIndicatorLayer : CALayer {
	//-------------------------------------------------------------------------
	//	コンストラクタ
	//-------------------------------------------------------------------------
	public init(rct:CGRect) {
		super.init()
		self.backgroundColor = UIColor.black.cgColor
		self.opacity = 0.3
		self.setNeedsDisplay()
		self.frame = rct
	}
	
	required public init?(coder aDecoder: NSCoder) {
		fatalError("init(coder:) has not been implemented")
	}
	//-------------------------------------------------------------------------
	//	描画処理
	//-------------------------------------------------------------------------
	open override func draw(in ctx: CGContext) {
		ctx.setFillColor(UIColor.white.cgColor)
		ctx.setStrokeColor(UIColor.white.cgColor)
		ctx.setLineWidth(3)
		let b = UIBezierPath(roundedRect: self.bounds, byRoundingCorners: UIRectCorner.allCorners, cornerRadii: CGSize(width: 5.0, height: 5.0))
		ctx.addPath(b.cgPath)
		ctx.strokePath()
	}
}
