//
//  N80Key.swift
//
//  Copyright (C) 2015-2016 Hiroshi Kanemoto.
//	Released under the MIT license
//	http://opensource.org/licenses/mit-license.php
//
//	 Created:	2016/04/05	H.Kanemoto
//	Modified:
//
import Foundation

open class N80Key : NSObject {
	fileprivate var _rect:CGRect!
	fileprivate var _code:UInt8 = 0
	fileprivate var _pushed:Bool = false
	open var Lable:String = ""
	open var Normal:Bool = true
	public static var Shift:Bool = false
	
	open var Rect:CGRect {
		get {
			return self._rect
		}
		set(value) {
			self._rect = value
		}
	}
	
	open var Code:UInt8 {
		return self._code
	}
	
	open var Pushed:Bool {
		get {
			return self._pushed
		}
		set(value) {
			self._pushed = value
		}
	}
	
	public init(code:UInt8, label:String) {
		super.init()
		self._rect = CGRect(x: 0, y: 0, width: 0, height: 0)
		self._code = code
		self.Lable = label
		self.Normal = true
	}
	
	public init(code:UInt8, label:String, isNormal:Bool) {
		super.init()
		self._rect = CGRect(x: 0, y: 0, width: 0, height: 0)
		self._code = code
		self.Lable = label
		self.Normal = isNormal
	}
	
	open func HitTest(_ pt:CGPoint) -> Bool {
		return pt.x >= self._rect!.minX && pt.x <= self._rect.maxX && pt.y >= self._rect.minY && pt.y <= self._rect.maxY
	}
}
