//
//  TouchRecord.swift
//
//  Copyright (C) 2015-2016 Hiroshi Kanemoto.
//	Released under the MIT license
//	http://opensource.org/licenses/mit-license.php
//
//	 Created:	2015/07/01	H.Kanemoto
//	Modified:
//
import Foundation

open class TouchRecord : NSObject {
	fileprivate var _InitialPos:CGPoint!
	fileprivate var _CurrentPos:CGPoint!
	fileprivate var _Rect:CGRect!
	fileprivate var _Key:N80Key? = nil
	open var Stick:VirtualStickLayer? = nil
	
	public init(initPosition:CGPoint) {
		super.init()
		self._InitialPos = initPosition
		self._CurrentPos = initPosition
	}
	
	deinit {
		if self._Key != nil {
			self._Key?.Pushed = false
			self._Key = nil
		}
		if self.Stick != nil {
			self.Stick?.Captured = false
			self.Stick = nil
		}
	}
	
	open var CurrentPos:CGPoint {
		get {
			return self._CurrentPos
		}
		set(value) {
			self._CurrentPos = value
		}
	}
	
	open var InitialPost:CGPoint {
		get {
			return self._InitialPos
		}
	}
	
	open var Key:N80Key? {
		get {
			return self._Key
		}
		set(value) {
			self._Key = value
		}
	}
}
