//
//  Line.swift
//
//  Copyright (C) 2015-2016 Hiroshi Kanemoto.
//	Released under the MIT license
//	http://opensource.org/licenses/mit-license.php
//
//	 Created:	2015/06/30	H.Kanemoto
//	Modified:
//
import Foundation

open class Line: NSObject {
    fileprivate var _X1:Double!
    fileprivate var _Y1:Double!
    fileprivate var _X2:Double!
    fileprivate var _Y2:Double!
    
    //プロパティ
    var X1:Double {
        get {
            return self._X1
        }
        set(value) {
            self._X1 = value
        }
    }
    var Y1:Double {
        get {
            return self._Y1
        }
        set(value) {
            self._Y1 = value
        }
    }
    var X2:Double {
        get {
            return self._X2
        }
        set(value) {
            self._X2 = value
        }
    }
    var Y2:Double {
        get {
            return self._Y2
        }
        set(value) {
            self._Y2 = value
        }
    }
    var Pos1:Position {
        get {
            return Position(x:self.X1, y:self.Y1)
        }
    }
    var Pos2:Position {
        get {
            return Position(x:self.X2, y:self.Y2)
        }
    }
    
    //コンストラクタ
    override init() {
        super.init()
        self.X1 = 0
        self.Y1 = 0
        self.X2 = 0
        self.Y2 = 0
    }
    public init(x1:Double, y1:Double, x2:Double, y2:Double) {
        super.init()
        self.X1 = x1
        self.Y1 = y1
        self.X2 = x2
        self.Y2 = y2
    }
    public init(a:Position, b:Position) {
        super.init()
        self.X1 = a.X
        self.Y1 = a.Y
        self.X2 = b.X
        self.Y2 = b.Y
    }
    public init(ab:Line) {
        super.init()
        self.X1 = ab.X1
        self.Y1 = ab.Y1
        self.X2 = ab.X2
        self.Y2 = ab.Y2
    }
    
    //メソッド
    open func move(_ offset:Position) {
        self.X1 += offset.X
        self.Y1 += offset.Y
        self.X2 += offset.X
        self.Y2 += offset.Y
    }
    open func offset(_ origin:Position) -> Line {
        // originを原点とした相対Lineを生成して返す
        return Line(a:origin.offset(self.Pos1), b:origin.offset(self.Pos2))
    }
    
    open func intersection(_ target:Line) -> Bool {
        return geometry.intersection(self.Pos1, p2: self.Pos2, p3: target.Pos1, p4: target.Pos2)
    }
}
