//
//  Meter.swift
//  AstroExplorer
//
//  Created by hiroshi on 2015/07/07.
//  Copyright © 2015年 hiroshi. All rights reserved.
//

import Foundation

public class Meter : NSObject {
    private var _full:Double!
    private var _value:Double!
    
    public var Value:Double {
        get {
            return self._value
        }
        set(value) {
            if value < 0 {
                self._value = 0
            } else if value > self._full {
                self._value = self._full
            } else {
                self._value = value
            }
        }
    }
    public var Full:Double {
        get {
            return self._full
        }
        set(value) {
            self._full = value
        }
    }
    
    override init() {
        super.init()
        self._full = 100
        self._value = 0
    }
    public init(full:Double) {
        super.init()
        self._full = full
        self._value = 0
    }
    public init(full:Double, value:Double) {
        super.init()
        self._full = full
        self.Value = value
    }
    public func full() {
        self.Value = self._full
    }
    public func empty() {
        self.Value = 0
    }
    public func add(value:Double) -> Double {
        var effect:Double = 0
        if value > 0 {
            var v = self.Value + value
            if v > self.Full {
                effect = self.Full - self.Value
                v = self.Full
            } else {
                effect = value
            }
            self.Value = v
        }
        return effect
    }
    public func gain(value:Double) -> Double {
        var effect:Double = 0
        if value > 0 {
            var v = self.Value - value
            if v < 0 {
                effect = self.Value
                v = 0
            } else {
                effect = value
            }
            self.Value = v
        }
        return effect
    }
    public var Rack:Double {
        return self.Full - self.Value
    }
    public var Percentage:Double {
        return self.Value / self.Full * 100
    }
}