//
//  N80ConfigViewController.swift
//
//  Copyright (C) 2016 Hiroshi Kanemoto.
//	Released under the MIT license
//	http://opensource.org/licenses/mit-license.php
//
//	 Created:	2016/04/08	H.Kanemoto
//	Modified:
//
import Foundation

open class N80ConfigViewController : UITableViewController, UIPickerViewDelegate, UIPickerViewDataSource  {
	var delegate:ViewController? = nil
	fileprivate var keylablles:[String]? = [String]()
	
    @IBOutlet weak var swInterrace: UISwitch!
    
	@IBOutlet weak var srgStickType: UISegmentedControl!
	@IBOutlet weak var srgStickDir: UISegmentedControl!
	@IBOutlet weak var sldMaxScalar: UISlider!
	@IBOutlet weak var sldPlayOfStick: UISlider!
	
	@IBOutlet weak var pkrButton1: UIPickerView!
	@IBOutlet weak var srgButton1x: UISlider!
	@IBOutlet weak var srgButton1y: UISlider!
	@IBOutlet weak var srgButton1size: UISlider!
	
	@IBOutlet weak var pkrButton2: UIPickerView!
	@IBOutlet weak var srgButton2x: UISlider!
	@IBOutlet weak var srgButton2y: UISlider!
	@IBOutlet weak var srgButton2size: UISlider!
	
	@IBOutlet weak var pkrButton3: UIPickerView!
	@IBOutlet weak var srgButton3x: UISlider!
	@IBOutlet weak var srgButton3y: UISlider!
	@IBOutlet weak var srgButton3size: UISlider!
	
	override open func viewDidLoad() {
		let appDelegate:AppDelegate = UIApplication.shared.delegate as! AppDelegate
		for k in appDelegate.keys {
			if k.Normal {
				self.keylablles?.append(k.Lable)
			}
		}
		self.keylablles?.append("なし")
		self.pkrButton1.delegate = self
		self.pkrButton2.delegate = self
		self.pkrButton3.delegate = self
		let w = UIScreen.main.bounds.width
		let h = UIScreen.main.bounds.height
		self.srgButton1x.maximumValue = Float(w)
		self.srgButton2x.maximumValue = Float(w)
		self.srgButton3x.maximumValue = Float(w)
		self.srgButton1y.maximumValue = Float(h)
		self.srgButton2y.maximumValue = Float(h)
		self.srgButton3y.maximumValue = Float(h)
		self.setValues()
	}
	
	@IBAction func touchUpQuit(_ sender: AnyObject) {
		self.getValues()
        let appDelegate:AppDelegate = UIApplication.shared.delegate as! AppDelegate
        appDelegate.N80EM.n80gr.chg_palette(self.swInterrace.isOn)
		self.view.endEditing(true)
		self.dismiss(animated: true, completion: nil)
	}
	
	@IBAction func touchUpIninialValue(_ sender: AnyObject) {
		let appDelegate:AppDelegate = UIApplication.shared.delegate as! AppDelegate
		appDelegate.setInitialValues()
		self.setValues()
	}
	
	override open func viewWillDisappear(_ animated: Bool) {
//		self.delegate?.icadeview.active = true
//		self.keylablles?.removeAll()
	}
    override open func viewDidDisappear(_ animated: Bool) {
        self.delegate?.icadeview?.active = true
        self.keylablles?.removeAll()
    }
	//-------------------------------------------------------------------------
	//	値取得／設定処理
	//-------------------------------------------------------------------------
	func setValues() {
		let appDelegate:AppDelegate = UIApplication.shared.delegate as! AppDelegate
        self.swInterrace.setOn(appDelegate.Interrace, animated: false)
		switch appDelegate.StickType {
		case VPSTICK_STICKTYPE.adjust_CENTER:
			self.srgStickType.selectedSegmentIndex = 1
		case VPSTICK_STICKTYPE.adjust_NEAR:
			self.srgStickType.selectedSegmentIndex = 2
		default:
			self.srgStickType.selectedSegmentIndex = 0
		}
		switch appDelegate.StickDir {
		case VPSTICK_STICKDIR.dir_2:
			self.srgStickDir.selectedSegmentIndex = 0
		case VPSTICK_STICKDIR.dir_4:
			self.srgStickDir.selectedSegmentIndex = 1
		default:
			self.srgStickDir.selectedSegmentIndex = 2
		}
		self.sldMaxScalar.value = Float(appDelegate.maxScalar)
		self.sldPlayOfStick.value = Float(appDelegate.playOfStick)
		self.pkrButton1.selectRow((self.keylablles?.firstIndex(of: appDelegate.Button1Label))!, inComponent: 0, animated: false)
		self.pkrButton2.selectRow((self.keylablles?.firstIndex(of: appDelegate.Button2Label))!, inComponent: 0, animated: false)
		self.pkrButton3.selectRow((self.keylablles?.firstIndex(of: appDelegate.Button3Label))!, inComponent: 0, animated: false)
		self.srgButton1x.value = Float(appDelegate.Button1Pt.x)
		self.srgButton2x.value = Float(appDelegate.Button2Pt.x)
		self.srgButton3x.value = Float(appDelegate.Button3Pt.x)
		self.srgButton1y.value = Float(appDelegate.Button1Pt.y)
		self.srgButton2y.value = Float(appDelegate.Button2Pt.y)
		self.srgButton3y.value = Float(appDelegate.Button3Pt.y)
		self.srgButton1size.value = Float(appDelegate.Button1Size)
		self.srgButton2size.value = Float(appDelegate.Button2Size)
		self.srgButton3size.value = Float(appDelegate.Button3Size)
	}
	
	func getValues() {
		let appDelegate:AppDelegate = UIApplication.shared.delegate as! AppDelegate
        appDelegate.Interrace = self.swInterrace.isOn
		switch self.srgStickType.selectedSegmentIndex {
		case 1:
			appDelegate.StickType = VPSTICK_STICKTYPE.adjust_CENTER
		case 2:
			appDelegate.StickType = VPSTICK_STICKTYPE.adjust_NEAR
		default:
			appDelegate.StickType = VPSTICK_STICKTYPE.fixed
		}
		switch  self.srgStickDir.selectedSegmentIndex {
		case 0:
			appDelegate.StickDir = VPSTICK_STICKDIR.dir_2
		case 1:
			appDelegate.StickDir = VPSTICK_STICKDIR.dir_4
		default:
			appDelegate.StickDir = VPSTICK_STICKDIR.dir_8
		}
		
		appDelegate.maxScalar = Double(self.sldMaxScalar.value)
		appDelegate.playOfStick = Double(self.sldPlayOfStick.value)
		appDelegate.Button1Label = self.keylablles![self.pkrButton1.selectedRow(inComponent: 0)]
		appDelegate.Button2Label = self.keylablles![self.pkrButton2.selectedRow(inComponent: 0)]
		appDelegate.Button3Label = self.keylablles![self.pkrButton3.selectedRow(inComponent: 0)]
		appDelegate.Button1Pt = CGPoint(x: CGFloat(self.srgButton1x.value), y: CGFloat(self.srgButton1y.value))
		appDelegate.Button2Pt = CGPoint(x: CGFloat(self.srgButton2x.value), y: CGFloat(self.srgButton2y.value))
		appDelegate.Button3Pt = CGPoint(x: CGFloat(self.srgButton3x.value), y: CGFloat(self.srgButton3y.value))
		appDelegate.Button1Size = CGFloat(self.srgButton1size.value)
		appDelegate.Button2Size = CGFloat(self.srgButton2size.value)
		appDelegate.Button3Size = CGFloat(self.srgButton3size.value)
		appDelegate.saveUserDefault()
	}
	//-------------------------------------------------------------------------
	//	PickerView delegate処理
	//-------------------------------------------------------------------------
	open func numberOfComponents(in pickerView: UIPickerView) -> Int {
		return 1
	}
	open func pickerView(_ pickerView: UIPickerView, numberOfRowsInComponent component: Int) -> Int {
		return self.keylablles!.count
	}
	open func pickerView(_ pickerView: UIPickerView, titleForRow row: Int, forComponent component: Int) -> String? {
		return self.keylablles![row]
	}
}
