//
//  N80LocalFileViewController.swift
//
//  Copyright (C) 2016 Hiroshi Kanemoto.
//	Released under the MIT license
//	http://opensource.org/licenses/mit-license.php
//
//	 Created:	2016/04/22	H.Kanemoto
//	Modified:
//
import Foundation

open class N80LocalFileViewController : UITableViewController {
	var file_name_list:[String] = [String]()
	var delegate:ViewController? = nil
	var proxy:subclass!
	var folder_path:String!
	
	@IBOutlet weak var tblFiles: UITableView!
	@IBOutlet weak var srgOperation: UISegmentedControl!
	
	override open func viewDidLoad() {
		super.viewDidLoad()
		
		self.proxy = subclass(parent: self)
		self.tblFiles.delegate = self.proxy
		self.tblFiles.dataSource = self.proxy
		self.srgOperation.selectedSegmentIndex = 0
		self.enumLocalDocuments()
	}
	
	override open func viewWillDisappear(_ animated: Bool) {
        NSLog("unload $$$$$$$$$$$$$$$$$")
		self.delegate?.icadeview?.active = true
        self.releaseResources()
    }
	
	func enumLocalDocuments() {
		let paths = NSSearchPathForDirectoriesInDomains(
			FileManager.SearchPathDirectory.documentDirectory,
			FileManager.SearchPathDomainMask.userDomainMask, true)
		self.folder_path = paths[0]
		let mgr = FileManager()
		let files:[String]? = try! mgr.contentsOfDirectory(atPath: self.folder_path)
		if files != nil {
			self.file_name_list = files!
		}
		self.tblFiles.reloadData()
	}
	
	open class subclass : NSObject, UITableViewDataSource, UITableViewDelegate {
		fileprivate var delegate:N80LocalFileViewController!
		
		public init(parent:N80LocalFileViewController) {
			self.delegate = parent
		}
		open func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
			return self.delegate.proxy_tableView(tableView, numberOfRowsInSection: section)
		}
		open func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
			return self.delegate.proxy_tableView(tableView, cellForRowAtIndexPath: indexPath)
		}
		
		open func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
			self.delegate.proxy_tableView(tableView, didSelectRowAtIndexPath: indexPath)
		}
	}
	
	open func proxy_tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
		return file_name_list.count
	}
 
	open func proxy_tableView(_ tableView: UITableView, cellForRowAtIndexPath indexPath: IndexPath) -> UITableViewCell {
		let cell: UITableViewCell = UITableViewCell(style: UITableViewCell.CellStyle.subtitle, reuseIdentifier: "Cell")
		
		cell.textLabel?.text = file_name_list[indexPath.row]
		return cell
	}
	
	open func proxy_tableView(_ tableView: UITableView, didSelectRowAtIndexPath indexPath: IndexPath) {
		let fn = self.folder_path + "/" + self.file_name_list[indexPath.row]
		
		if self.srgOperation.selectedSegmentIndex == 0 {
			//read file
			let data:bytecoder? = n80em.loadFile(fn)
			if data != nil {
				let ufn = self.file_name_list[indexPath.row].uppercased()
				if ufn.range(of: ".CMT") != nil {
					self.delegate?.recvCMTData(data!)
				} else {
					self.delegate?.recvN80Data(data!)
				}
				self.view.endEditing(true)
				self.dismiss(animated: true, completion: nil)
			}
		} else {
			//delete file
			let mgr = FileManager()
			try! mgr.removeItem(atPath: fn)
			self.enumLocalDocuments()
		}
	}
	
	func releaseResources() {
		self.file_name_list.removeAll()
	}
	
	@IBAction func touchUpQuit(_ sender: AnyObject) {
		self.view.endEditing(true)
		self.dismiss(animated: true, completion: nil)
	}
}
