//
//  DER.h
//
//  Copyright (C) 2016 Hiroshi Kanemoto.
//	Released under the MIT license
//	http://opensource.org/licenses/mit-license.php
//
//	 Created:	2016/03/14	H.Kanemoto
//	Modified:
//
#ifndef DER_h
#define DER_h
#import	"bytecoder.h"

@class DER_PARSE_RESULT;
/*----------------------------------------------------------------------
 *	ASN.1 DER (Tiny)
 *----------------------------------------------------------------------*/
@interface DER : TBObject {
@protected
	NSMutableArray<DER *> *childs;
	UInt8		tag;
	UInt8		len_seriarized[8];
	int			len_seriarized_cnt;
	bytecoder	*contents;
}
@property (nonatomic, assign, getter=getTag, setter=setTag:) UInt8 Tag;
@property (nonatomic, assign, getter=getContentsLen) int32_t ContentsLen;
@property (nonatomic, getter=getContentsData) UInt8 *ContentsData;
@property (nonatomic, assign, getter=getSerializedLen) UInt8 *SerializedLen;
@property (nonatomic, assign, getter=getSerializedLenCnt) int32_t SerializedLenCnt;
@property (nonatomic, readonly, getter=getSubItems) NSMutableArray<DER *> *SubItems;

+(BOOL)parse:(DER_PARSE_RESULT *)r;
+(DER *)OID_SPNEGO;
+(DER *)OID_NTLM;

-(id)initWith:(UInt8)tag : (bytecoder *)contents;
-(BOOL)parse;
-(void)len_serialze;
-(void)len_serialze:(int32_t)size;
-(int32_t)serialize:(bytecoder *)coder;
-(BOOL)add:(DER *)target;
-(BOOL)add:(const UInt8 *)target : (int)len;
-(bytecoder*)detach;
@end
/*----------------------------------------------------------------------
 *	SEQUENCE CONSTRUCTED DER
 *----------------------------------------------------------------------*/
@interface DER_SEQ_CONSTRUCTED : DER {
@protected
	DER *seq;
}
@end
/*----------------------------------------------------------------------
 *	DER PARSE RESULT
 *----------------------------------------------------------------------*/
@interface DER_PARSE_RESULT : NSObject {
@protected
	bytecoder *data;
	NSMutableArray<DER *> *items;
}
@property (nonatomic, readonly, getter=getItems) NSMutableArray<DER *> *Items;
@property (nonatomic, readonly, getter=getData) bytecoder *Data;

-(id)initWith:(bytecoder *)coder;
@end

#endif /* DER_h */
