/*
 *  RFC 1321 compliant MD5 implementation
 *
 *  Copyright (C) 2001-2003  Christophe Devine
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef MD5_h
#define MD5_h
typedef struct
{
    UInt32 total[2];
    UInt32 state[4];
    UInt8 buffer[64];
}
md5_context;

@interface MD5 : NSObject {
	@private
	md5_context ctx;
}
-(void)start;
-(void)update:(UInt8 *)buffer : (int)length;
-(void)finish:(UInt8[16]) result;

@end
#endif /* MD5_h */
