//
//  DCE.h
//
//  Copyright (C) 2016 Hiroshi Kanemoto.
//	Released under the MIT license
//	http://opensource.org/licenses/mit-license.php
//
//	 Created:	2016/03/17	H.Kanemoto
//	Modified:
//
#ifndef DCE_h
#define DCE_h

typedef struct __attribute__((packed)) {
	UInt8	rpc_vers;
	UInt8	rpc_vers_minor;
	UInt8	PTYPE;
	UInt8	pfc_flags;
	UInt8	packed_drep[4];
	UInt16	frag_length;
	UInt16	auth_length;
	UInt32	call_id;
}	rpc_pkt_hdr;

typedef struct __attribute__((packed)) {
	UInt32	alloc_hint;
	UInt16	p_cont_id;
	UInt16	opnum;
}	rpcconn_request_hdr_t;

typedef struct __attribute__((packed)) {
	UInt32	alloc_hint;
	UInt16	p_cont_id;
	UInt8	cancel_count;
	UInt8	reserved;
}	rpcconn_response_hdr_t;

typedef struct __attribute__((packed)) {
	UInt8	if_uuid[16];
	UInt32	if_version;
}	p_syntax_id_t;

typedef struct __attribute__((packed)) {
	UInt16	p_cont_id;
	UInt8	n_transfer_syn;
	UInt8	reserved;
	p_syntax_id_t abstract_syntax;
	//p_syntax_id_t transfer_syntaxes[];
}	p_cont_elem_t;

typedef struct __attribute__((packed)) {
	UInt8	n_context_elem;
	UInt8	reserved;
	UInt16	reserved2;
	//p_cont_elem_t p_cont_elem[];
}	p_cont_list_t;

typedef struct __attribute__((packed)) {
	UInt16 max_xmit_frag;
	UInt16 max_recv_frag;
	UInt32 assoc_group_id;
	//p_cont_list_t p_context_elem;
}	rpcconn_bind_hdr_t;

typedef struct __attribute__((packed)) {
	UInt16	result;
	UInt16	reason;
	p_syntax_id_t	transfer_syntax;
}	p_result_t;

typedef struct __attribute__((packed)) {
	UInt8	n_results;
	UInt8	reserved;
	UInt16	reserved2;
	p_result_t	p_results[];
}	p_result_list_t;

typedef struct __attribute__((packed)) {
	UInt16	length;
	UInt8	port_spec[];
}	port_any_t;

typedef struct __attribute__((packed)) {
	UInt16 max_xmit_frag;
	UInt16 max_recv_frag;
	UInt32 assoc_group_id;
	//port_any_t	sec_addr;
	//p_result_list_t	p_result_list;
}	rpcconn_bind_ack_hdr_t;

typedef struct __attribute__((packed)) {
	UInt32	ref_id;
	UInt32	max_count;
	UInt32	offset;
	UInt32	act_count;
	//UInt8	buffer[];
}	p_string;

typedef struct __attribute__((packed)) {
	UInt32	max_count;
	UInt32	offset;
	UInt32	act_count;
	//UInt8	buffer[];
}	p_string2;

typedef struct __attribute__((packed)) {
	UInt32	ctl;
	UInt32	ref_id;
	UInt32	count;
	UInt32	pt2array;
}	p_netsharectl_req;

typedef struct __attribute__((packed)) {
	UInt32	ctl;
	UInt32	ref_id;
	UInt32	count;
	UInt32	pt2array;
	UInt32	max_count;
}	p_netsharectl_res;

typedef struct __attribute__((packed)) {
	UInt32	ref_id;
	UInt32	handle;
}	p_resume_handle;

typedef struct __attribute__((packed)) {
	UInt32	name_ref_id;
	UInt32	type;
	UInt32	comment_ref_id;
}	p_share_info_1;

typedef struct __attribute__((packed)) {	//Hi
	p_string	server_name;				//variable length
}	rpcconn_request_netshareenumall_h;

typedef struct __attribute__((packed)) {	//Low
	//p_string	server_name;
	UInt32		level;
	p_netsharectl_req	ctl;
	UInt32		max_buffer;
	p_resume_handle		handle;
}	rpcconn_request_netshareenumall_l;

typedef struct __attribute__((packed)) {	//Hi
	UInt32		level;
	p_netsharectl_res	ctl;
	//p_share_info_1		array[];		//variable length
}	rpcconn_response_netshareenumall_h;

typedef struct __attribute__((packed)) {	//Low
	UInt32		total_count;
	p_resume_handle		handle;
}	rpcconn_response_netshareenumall_l;

#endif /* DCE_h */
