//
//  FileIdBothDirInformation.m
//
//  Copyright (C) 2016 Hiroshi Kanemoto.
//	Released under the MIT license
//	http://opensource.org/licenses/mit-license.php
//
//	 Created:	2016/03/22	H.Kanemoto
//	Modified:
//
#import <Foundation/Foundation.h>
#import "FSCC.h"
/*----------------------------------------------------------------------*
 *	FileIdBothDirInformation
 *----------------------------------------------------------------------*/
@implementation FileIdBothDirInformation

-(id)init {
	if (self = [super init]) {
		self->filename = nil;
		memset(&self->info, 0, sizeof(FILE_ID_BOTH_DIR_INFORMATION));
	}
	return self;
}
-(void)dealloc {
	DLog(@"");
}

-(FILE_ID_BOTH_DIR_INFORMATION*)getInfo {
	return &self->info;
}
-(NSString*)getFileName {
	return self->filename != nil ? self->filename.text : @"";
}
-(BOOL)getIsDir {
	return self.Info->FileAttributes & FILE_ATTRIBUTE_DIRECTORY;
}
-(BOOL)getIsReadonly {
	return self.Info->FileAttributes & FILE_ATTRIBUTE_READONLY;
}

-(BOOL)deserialize:(bytecoder*)coder {
	BOOL result = false;
	for (;;){
		if (![coder pull:(UInt8*)&self->info Length:sizeof(FILE_ID_BOTH_DIR_INFORMATION)])
			break;
		UInt8 buffer[self->info.FileNameLength];
		if (![coder pull:buffer Length:self->info.FileNameLength])
			break;
		self->filename = [UCS2 create:buffer length:self->info.FileNameLength];
		result = true;
		break;
	}
	return result;
}

@end
