//
//  FileStandardInformation.m
//
//  Copyright (C) 2016 Hiroshi Kanemoto.
//	Released under the MIT license
//	http://opensource.org/licenses/mit-license.php
//
//	 Created:	2016/03/23	H.Kanemoto
//	Modified:
//
#import <Foundation/Foundation.h>
#import "FSCC.h"
/*----------------------------------------------------------------------*
 *	FileStandardInformation
 *----------------------------------------------------------------------*/
@implementation FileStandardInformation

-(id)init {
	if (self = [super init]) {
		memset(&self->info, 0, sizeof(FILE_STANDARD_INFORMATION));
	}
	return self;
}
-(void)dealloc {
	DLog(@"");
}

-(FILE_STANDARD_INFORMATION*)getInfo {
	return &self->info;
}
-(int64_t)getAlloc {
	return self.Info->AllocationSize;
}
-(int64_t)getEOF {
	return self.Info->EndOfFile;
}
-(BOOL)getDeletePending {
	return self.Info->DeletePending != 0;
}
-(BOOL)getDirectory {
	return self.Info->Directory != 0;
}

-(BOOL)deserialize:(bytecoder*)coder {
	return [coder pull:(UInt8*)&self->info Length:sizeof(FILE_STANDARD_INFORMATION)];
}

@end
