//
//  SMB2Close.m
//
//  Copyright (C) 2016 Hiroshi Kanemoto.
//	Released under the MIT license
//	http://opensource.org/licenses/mit-license.php
//
//	 Created:	2016/03/19	H.Kanemoto
//	Modified:
//
#import <Foundation/Foundation.h>
#import "SMB2Close.h"
/*----------------------------------------------------------------------*
 *	SMB2 CLOSE REQUEST
 *----------------------------------------------------------------------*/
@implementation SMB2ReqClose

-(id)initWith:(UInt32)TreeId FileId:(UInt8[16])FileId {
	if (self = [super init]) {
		if ([self.Coder alloc_buffer:PACKETHEADERSIZE+CLOSEREQSIZE]) {
			[super initheader:self.Header];
			self.Header->Command = SMB2_COMMAND_CLOSE;
			self.Header->s.Sync.TreeId = TreeId;
			memcpy(self.CLOSE->FileId, FileId, 16);
			self.CLOSE->StructureSize = CLOSEREQSIZE;
			self->close = self.CLOSE;	//for debugging
			//move pointer to payload top but except for dummy buffer[1]
			[self.Coder consume:PACKETHEADERSIZE+CLOSEREQSIZE];
		} else
			return nil;
	}
	return self;
}

-(reqCLOSE *)getClose {
	return (reqCLOSE*) &self.Coder.Data[PACKETHEADERSIZE];
}
@end
/*----------------------------------------------------------------------*
 *	SMB2 CLOSE RESPONSE
 *----------------------------------------------------------------------*/
@implementation SMB2ResClose

-(id)init {
	if (self = [super init]) {
		if ([self.Coder alloc_buffer:PACKETHEADERSIZE+CLOSERESSIZE]) {
			self.CLOSE->StructureSize = CLOSERESSIZE;
			self->close = self.CLOSE;	//for debugging
		} else
			return nil;
	}
	return self;
}

-(resCLOSE *)getClose {
	return (resCLOSE*) &self.Coder.Data[PACKETHEADERSIZE];
}
@end