//
//  SMB2Create.h
//
//  Copyright (C) 2016 Hiroshi Kanemoto.
//	Released under the MIT license
//	http://opensource.org/licenses/mit-license.php
//
//	 Created:	2016/03/18	H.Kanemoto
//	Modified:
//
#ifndef SMB2Create_h
#define SMB2Create_h
#import "SMB2Header.h"
@class SMB2CreateContext;
/*----------------------------------------------------------------------*
 *	SMB2 CREATE REQUEST
 *----------------------------------------------------------------------*/
@interface SMB2ReqCreate : SMB2Header {
	reqCREATE	*create;	//debugger
	UCS2		*FileName;
	NSMutableArray<SMB2CreateContext*>	*ctxes;
}
@property (nonatomic, readonly, assign, getter=getCreate) reqCREATE *CREATE;
@property (nonatomic, assign, getter=getOplockLevel, setter=setOplockLevel:) UInt8 OplockLevel;
@property (nonatomic, assign, getter=getDesiredAccess, setter=setDesiredAccess:) UInt32 DesiredAccess;
@property (nonatomic, assign, getter=getFileAttributes, setter=setFileAttributes:) UInt32 FileAttributes;
@property (nonatomic, assign, getter=getShareAccess, setter=setShareAccess:) UInt32 ShareAccess;
@property (nonatomic, assign, getter=getCreateDisposition, setter=setCreateDisposition:) UInt32 CreateDisposition;
@property (nonatomic, assign, getter=getCreateOptions, setter=setCreateOptions:) UInt32 CreateOptions;

+(SMB2ReqCreate*)createPipe:(UInt32)TreeId PipeName:(NSString*)FileName;
+(SMB2ReqCreate*)createDir:(UInt32)TreeId DirName:(NSString*)dirname;
+(SMB2ReqCreate*)createFile:(UInt32)TreeId FileName:(NSString*)filename;

-(BOOL)serialize;

@end
/*----------------------------------------------------------------------*
 *	SMB2 CREATE RESPONSE
 *----------------------------------------------------------------------*/
@interface SMB2ResCreate : SMB2Header {
}
@property (nonatomic, readonly, assign, getter=getCreate) resCREATE *CREATE;

@end
/*----------------------------------------------------------------------*
 *	SMB2 CREATE CONTEXT
 *----------------------------------------------------------------------*/
@interface SMB2CreateContext : NSObject {
	SMB2_CREATE_CONTEXT	context;
	UInt8				name[16];
	int					name_len;
}
@property (nonatomic, readonly, assign, getter=getContext) SMB2_CREATE_CONTEXT *CONTEXT;

+(SMB2CreateContext*)createMxAc;

-(BOOL)serialize:(bytecoder*)coder;
@end

#endif /* SMB2Create_h */
