//
//  SMB2Ioctl.m
//
//  Copyright (C) 2016 Hiroshi Kanemoto.
//	Released under the MIT license
//	http://opensource.org/licenses/mit-license.php
//
//	 Created:	2016/03/20	H.Kanemoto
//	Modified:
//
#import <Foundation/Foundation.h>
#import "SMB2Ioctl.h"
/*----------------------------------------------------------------------*
 *	SMB2 IOCTL REQUEST
 *----------------------------------------------------------------------*/
@implementation SMB2ReqIoctl

-(id)initWith:(UInt32)TreeId FileId:(UInt8[16])FileId; {
	if (self = [super init]) {
		if ([self.Coder alloc_buffer:PACKETHEADERSIZE+IOCTLREQSIZE]) {
			[super initheader:self.Header];
			self.Header->Command = SMB2_COMMAND_IOCTL;
			self.Header->s.Sync.TreeId = TreeId;
			memcpy(self.IOCTL->FileId, FileId, 16);
			self.IOCTL->StructureSize = IOCTLREQSIZE;
			self.IOCTL->InputOffset = 0x78;
			self.IOCTL->MaxInputResponse = 0;
			self.IOCTL->MaxOutputResponse = 65536;
			self->ioctl = self.IOCTL;	//for debugging
			//move pointer to payload top except for dummy buffer[1]
			[self.Coder consume:PACKETHEADERSIZE+IOCTLREQSIZE-1];
		} else
			return nil;
	}
	return self;
}

-(reqIOCTL *)getIoctl {
	return (reqIOCTL*) &self.Coder.Data[PACKETHEADERSIZE];
}
@end
/*----------------------------------------------------------------------*
 *	SMB2 IOCTL RESPONSE
 *----------------------------------------------------------------------*/
@implementation SMB2ResIoctl

-(id)init {
	if (self = [super init]) {
		if ([self.Coder alloc_buffer:PACKETHEADERSIZE+CLOSERESSIZE]) {
			self.IOCTL->StructureSize = CLOSERESSIZE;
			self->ioctl = self.IOCTL;	//for debugging
		} else
			return nil;
	}
	return self;
}

-(resIOCTL *)getIoctl {
	return (resIOCTL*) &self.Coder.Data[PACKETHEADERSIZE];
}
@end