//
//  SMB2QueryDirectory.m
//
//  Copyright (C) 2016 Hiroshi Kanemoto.
//	Released under the MIT license
//	http://opensource.org/licenses/mit-license.php
//
//	 Created:	2016/03/21	H.Kanemoto
//	Modified:
//
#import <Foundation/Foundation.h>
#import "SMB2QueryDirectory.h"
/*----------------------------------------------------------------------*
 *	SMB2 QUERY DIRECTORY REQUEST
 *----------------------------------------------------------------------*/
@implementation SMB2ReqQueryDirectory

-(id)init {
	if (self = [super init]) {
		if ([self.Coder alloc_buffer:PACKETHEADERSIZE+QUERYDIRREQSIZE]) {
			[super initheader:self.Header];
			self.Header->Command = SMB2_COMMAND_QUERY_DIRECTORY;
			self.QUERYDIR->StructureSize = QUERYDIRREQSIZE;
			self.QUERYDIR->FileInformationClass = FIC_FileIdBothDirectoryInformation;
			self.QUERYDIR->OutputBufferLength = 0x10000;
			self.Header->CreditCharge = (int16_t)(1 + (self.QUERYDIR->OutputBufferLength - 1)/65536);
			self.QUERYDIR->FileNameOffset = 0x60;
			self->querydir = self.QUERYDIR;	//for debugging
			//move pointer to payload top except for dummy buffer[1]
			[self.Coder consume:PACKETHEADERSIZE+QUERYDIRREQSIZE];
		} else
			return nil;
	}
	return self;
}

+(SMB2ReqQueryDirectory*)create:(UInt32)TreeId
	FileId:(UInt8[16])FileId FileName:(NSString *)FileName
{
	SMB2ReqQueryDirectory *req = [[SMB2ReqQueryDirectory alloc] init];
	if (req != nil) {
		req.Header->s.Sync.TreeId = TreeId;
		memcpy(req.QUERYDIR->FileId, FileId, 16);
		req->querydir = req.QUERYDIR;	//for debugging
		if (FileName != nil) {
			UCS2 *fn = [UCS2 create:FileName];
			if (fn.ByteLen > 0) {
				[req.Coder rewind];
				[req.Coder consume:PACKETHEADERSIZE+QUERYDIRREQSIZE-1];
				[req.Coder push:fn.Ptr Length:fn.ByteLen];
				req.QUERYDIR->FileNameLength = fn.ByteLen;
			}
		}
	}
	return req;
}

-(reqQUERY_DIRECTORY *)getQuery {
	return (reqQUERY_DIRECTORY*) &self.Coder.Data[PACKETHEADERSIZE];
}
@end
/*----------------------------------------------------------------------*
 *	SMB2 QUERY DIRECTORY RESPONSE
 *----------------------------------------------------------------------*/
@implementation SMB2ResQueryDirectory

-(id)init {
	if (self = [super init]) {
		if ([self.Coder alloc_buffer:PACKETHEADERSIZE+QUERYDIRRESSIZE]) {
			self.QUERYDIR->StructureSize = QUERYDIRRESSIZE;
			self->querydir = self.QUERYDIR;	//for debugging
		} else
			return nil;
	}
	return self;
}

-(resQUERY_DIRECTORY *)getQuery {
	return (resQUERY_DIRECTORY*) &self.Coder.Data[PACKETHEADERSIZE];
}
@end