//
//  SMB2QueryInfo.m
//
//  Copyright (C) 2016 Hiroshi Kanemoto.
//	Released under the MIT license
//	http://opensource.org/licenses/mit-license.php
//
//	 Created:	2016/03/23	H.Kanemoto
//	Modified:
//
#import <Foundation/Foundation.h>
#import "SMB2QueryInfo.h"
/*----------------------------------------------------------------------*
 *	SMB2 READ REQUEST
 *----------------------------------------------------------------------*/
@implementation SMB2ReqQueryInfo

-(id)init {
	if (self = [super init]) {
		if ([self.Coder alloc_buffer:PACKETHEADERSIZE+QUERYINFOREQSIZE]) {
			[super initheader:self.Header];
			self.Header->Command = SMB2_COMMAND_QUERY_INFO;
			self.QUERYINFO->StructureSize = QUERYINFOREQSIZE;
			self->queryinfo = self.QUERYINFO;	//for debugging
			//move pointer to payload top except for dummy buffer[1]
			[self.Coder consume:PACKETHEADERSIZE+QUERYINFOREQSIZE-1];
		} else
			return nil;
	}
	return self;
}

-(reqQUERY_INFO *)getQuery {
	return (reqQUERY_INFO*) &self.Coder.Data[PACKETHEADERSIZE];
}

+(SMB2ReqQueryInfo*)create:(UInt32)TreeId FileId:(UInt8[16])FileId {
	SMB2ReqQueryInfo *req = [[SMB2ReqQueryInfo alloc] init];
	if (req != nil) {
		req.Header->s.Sync.TreeId = TreeId;
		req.QUERYINFO->InfoType = 1;			//SMB2_0_INFO_FILE
		req.QUERYINFO->FileInfoClass = 5;		//FileStardardInformation
		req.QUERYINFO->OutputBufferLength = 24;	//sizeof(FileStardardInformation)
		memcpy(req.QUERYINFO->FileId, FileId, 16);
	}
	return req;
}

@end
/*----------------------------------------------------------------------*
 *	SMB2 READ RESPONSE
 *----------------------------------------------------------------------*/
@implementation SMB2ResQueryInfo

-(id)init {
	if (self = [super init]) {
		if ([self.Coder alloc_buffer:PACKETHEADERSIZE+QUERYINFORESSIZE]) {
			self.QUERYINFO->StructureSize = QUERYINFORESSIZE;
			self->queryinfo = self.QUERYINFO;	//for debugging
		}
	}
	return self;
}

-(resQUERY_INFO *)getQuery {
	return (resQUERY_INFO*) &self.Coder.Data[PACKETHEADERSIZE];
}
@end
