//
//  SMB2Read.m
//
//  Copyright (C) 2016 Hiroshi Kanemoto.
//	Released under the MIT license
//	http://opensource.org/licenses/mit-license.php
//
//	 Created:	2016/03/23	H.Kanemoto
//	Modified:
//
#import <Foundation/Foundation.h>
#import "SMB2Read.h"
/*----------------------------------------------------------------------*
 *	SMB2 READ REQUEST
 *----------------------------------------------------------------------*/
@implementation SMB2ReqRead

-(id)init {
	if (self = [super init]) {
		if ([self.Coder alloc_buffer:PACKETHEADERSIZE+READREQSIZE]) {
			[super initheader:self.Header];
			self.Header->Command = SMB2_COMMAND_READ;
			self.READ->StructureSize = READREQSIZE;
			self->read = self.READ;	//for debugging
			//move pointer to payload top except for dummy buffer[1]
			[self.Coder consume:PACKETHEADERSIZE+READREQSIZE-1];
		} else
			return nil;
	}
	return self;
}

-(reqREAD *)getRead {
	return (reqREAD*) &self.Coder.Data[PACKETHEADERSIZE];
}
@end
/*----------------------------------------------------------------------*
 *	SMB2 READ RESPONSE
 *----------------------------------------------------------------------*/
@implementation SMB2ResRead

-(id)initWith:(int32_t)size {
	if (self = [super init]) {
		if ([self.Coder alloc_buffer:PACKETHEADERSIZE+READRESSIZE+size]) {
			self.READ->StructureSize = READRESSIZE;
			self->read = self.READ;	//for debugging
		} else
			return nil;
	}
	return self;
}

-(resREAD *)getRead {
	return (resREAD*) &self.Coder.Data[PACKETHEADERSIZE];
}
@end
