//
//  SMBConnection.h
//
//  Copyright (C) 2016 Hiroshi Kanemoto.
//	Released under the MIT license
//	http://opensource.org/licenses/mit-license.php
//
//	 Created:	2016/03/15	H.Kanemoto
//	Modified:
//
#ifndef SMBConnection_h
#define SMBConnection_h
#import "TcpClient.h"
#import "SMB2Header.h"
#import "SMB2Negotiate.h"
/*----------------------------------------------------------------------
 *	SMB CONNECTION
 *----------------------------------------------------------------------*/
@interface SMBConnection : TBObject {
@protected
	TcpClient*	tcp;
	NSString	*ip;
	int32_t		port;
	UInt8		clientguid[16];
	UInt8		serverguid[16];
	UInt64		msgid;
	BOOL		support_leasing;
	BOOL		support_large_mtu;
	BOOL		support_dir_leasing;
	BOOL		support_multi_ch;
	BOOL		support_persistent_hdl;
	BOOL		support_encryption;
	UInt32		max_transactsize;
	UInt32		max_readsize;
	UInt32		max_writesize;
	UInt16		dialect;
}
@property (nonatomic, readonly, getter=getTcp) TcpClient *Tcp;
@property (nonatomic, copy, readonly, getter=getIP) NSString *IP;
@property (nonatomic, assign, readonly, getter=getPort) int32_t Port;
@property (nonatomic, assign, readonly, getter=getSupportLeasing) BOOL SupportLeasing;
@property (nonatomic, assign, readonly, getter=getSupportMultiCredit) BOOL SupportMultiCredit;
@property (nonatomic, assign, readonly, getter=getSupportDirLeaseing) BOOL SupportDirLeasing;
@property (nonatomic, assign, readonly, getter=getSupportMultiChannel) BOOL SupportMultiChannel;
@property (nonatomic, assign, readonly, getter=getSupportPersistentHandle) BOOL SupportPersistentHandle;
@property (nonatomic, assign, readonly, getter=getSupportEncryption) BOOL SupportEncryption;
@property (nonatomic, assign, readonly, getter=getMaxTransactSize) UInt32 MaxTransactSize;
@property (nonatomic, assign, readonly, getter=getMaxReadSize) UInt32 MaxReadSize;
@property (nonatomic, assign, readonly, getter=getMaxWriteSize) UInt32 MaxWriteSize;
@property (nonatomic, assign, readonly, getter=getDialect) UInt16 Dialect;

-(id)initWith:(NSString *)ip Port:(int32_t)port;
-(UInt64)SequenceWindow:(int16_t)credit;
-(BOOL)Connect;
-(void)Disconnect;
-(BOOL)Negotiate;
-(BOOL)TcpReconnect;

@end

#endif /* SMBConnection_h */
