//
//  SMBOpen.h
//
//  Copyright (C) 2016 Hiroshi Kanemoto.
//	Released under the MIT license
//	http://opensource.org/licenses/mit-license.php
//
//	 Created:	2016/03/23	H.Kanemoto
//	Modified:	2017/05/24	H.Kanemoto  SMB Signature
//
#ifndef SMBOpen_h
#define SMBOpen_h
#import "SMBTreeConnect.h"
typedef void (^SMBReadProgressCallback)(NSData *data, int64_t ReadSize, int64_t TotalSize, BOOL finished, NSError *err);
/*----------------------------------------------------------------------*
 *	SMB OPEN
 *----------------------------------------------------------------------*/
@interface SMBOpen : TBObject {
	SMBTreeConnect	*treeconn;
	UInt32			treeid;
	UInt8			fileid[16];
	BOOL			autotreedisconnect;
	BOOL			opened;
}
@property (nonatomic) SMBSession *Session;
@property (nonatomic, readonly, weak, getter=getTreeConnect) SMBTreeConnect *TreeConnect;

-(id)initWith:(SMBTreeConnect*)treeconn FileId:(UInt8[16])fileid AutoDisconnect:(BOOL)autodisconnect;
-(void)read:(SMBReadProgressCallback)progress;
-(bytecoder*)read_once;
-(void)close;

@end

#endif /* SMBOpen_h */
