//
//  SMBTreeConnect.h
//
//  Copyright (C) 2016 Hiroshi Kanemoto.
//	Released under the MIT license
//	http://opensource.org/licenses/mit-license.php
//
//	 Created:	2016/03/21	H.Kanemoto
//	Modified:
//
#ifndef SMBTreeConnect_h
#define SMBTreeConnect_h
#import "SMBSession.h"
#import "SMB2Create.h"
#import "RPC.h"
#import "FSCC.h"
@class SMBOpen;
typedef void (^OpenFileCallback)(SMB2ReqCreate *);
typedef BOOL (^EnumDirCallback)(FileIdBothDirInformation *info);
/*----------------------------------------------------------------------
 *	SMB CONNECTION
 *----------------------------------------------------------------------*/
@interface SMBTreeConnect : TBObject {
	UInt32	treeid;
	BOOL	connected;
}
@property (nonatomic) SMBSession *Session;
@property (nonatomic) rpcShareInfo1 *ShareInfo;
@property (nonatomic, copy, readonly, getter=getShareName) NSString *ShareName;
@property (nonatomic, readonly, assign, getter=getTreeId) UInt32 TreeId;
@property (nonatomic, readonly, assign, getter=getConnected) BOOL Connected;

-(id)initWith:(SMBSession*)session ShareInfo:(rpcShareInfo1*)info;
-(BOOL)Connect;
-(BOOL)Disconnect;
-(NSMutableArray<FileIdBothDirInformation*>*)EnumDir:(NSString*)dirpath Callback:(EnumDirCallback)callback;
-(SMBOpen*)OpenFile:(NSString*)filename AutoDisconnect:(BOOL)autodisconnect Callback:(OpenFileCallback)callback;

@end

#endif /* SMBTreeConnect_h */
