//
//  SMBUtils.h
//
//  Copyright (C) 2016 Hiroshi Kanemoto.
//	Released under the MIT license
//	http://opensource.org/licenses/mit-license.php
//
//	 Created:	2016/03/12	H.Kanemoto
//	Modified:
//
#ifndef Utils_h
#define Utils_h
#import "UCS2.h"

@interface SMBUtils : TBObject {
}
+(UInt32)Byte2IntBE:(UInt8 *)buffer;
+(UInt32)Byte2IntLE:(UInt8 *)buffer;
+(UInt16)Byte2ShortLE:(UInt8 *)buffer;
+(UInt64)Byte2LongLE:(UInt8 *)buffer;

+(void)Int2ByteBE:(UInt32)val : (UInt8 *)buffer;
+(void)Short2ByteLE:(UInt16)val : (UInt8*)buffer;
+(void)Int2ByteLE:(UInt32)val : (UInt8*)buffer;
+(void)Long2ByteLE:(UInt64)val : (UInt8*)buffer;

+(int32_t)Align8bytes:(int32_t)offset;
+(int32_t)Align4bytes:(int32_t)offset;

+(void)GenUUID:(UInt8[16]) uuid;
+(void)SMBTimeStamp:(UInt8[8])stamp;
+(void)RandomArray:(UInt8 *)array Length:(int)len;

+(NSError*)buildErr:(TBErrors)code;

@end

#endif /* Utils_h */
