//
//  TBObject.h
//
//  Copyright (C) 2016 Hiroshi Kanemoto.
//	Released under the MIT license
//	http://opensource.org/licenses/mit-license.php
//
//	 Created:	2016/03/25	H.Kanemoto
//	Modified:
//
#ifndef TBObject_h
#define TBObject_h
#ifdef DEBUG
#   define DLog(fmt, ...) NSLog((@"%s [Line %d] " fmt), __PRETTY_FUNCTION__, __LINE__, ##__VA_ARGS__)
#else
#   define DLog(...)
#endif

typedef enum : NSInteger {
	TB_NO_ERR,
	TCP_RECV_TIMEOUT,
	TCP_RECV_ERROR,
	TCP_SEND_TIMEOUT,
	TCP_SEND_ERROR,
	
	SMB2_CONNECTION_ERR,
	SMB2_NEGOTIATE_REQ_ERR,
	SMB2_AUTHENTICATE_ERR,
	SMB2_QUERY_INFO_REQ_ERR,
	SMB2_READ_ERR
}	TBErrors;


@interface TBObject : NSObject {
@protected
	TBErrors err_code;
	NSError *err;
}
@property (nonatomic, readonly, getter=getLastErr) NSError *LastErr;
@property (nonatomic, readonly, assign, getter=getCode) TBErrors LastErrCode;

-(void)clearLastErr;
-(void)setLastErr:(NSError*)err;

@end

#endif /* TBObject_h */
